options.defaultValue("level") = false;
//plugin.onAddCustomMenuItems = AddCustomMenuItems;

var dir = "images/";

var blocksize = 16;
var mines = new Array();
var shown = new Array();
if(options("level")==true){
	var gridx =9;
	var gridy =9;	
	var maxmines=10;
}else{
	var gridx =16;
	var gridy =16;
	var maxmines=40;
}
var firstrun = false;
var firstrun_beg = false;
	var squaresleft, flagsleft;
	var elapsedtime=0;
	var playing;
	var placeflag;
	var clicked;
// Setup the icons, about dialog and flags.
view.caption = strTitle;
//newgame();
 RedrawAll();

	view.setInterval("ticker()", 1000);
// draw the board
function AddCustomMenuItems( Menu )
{
  var Level = ( options( "level" ) == true );
  
  Menu.AddItem( "Expert", Level ? 0 : gddMenuItemFlagChecked, OnBeginer );
  Menu.AddItem( "Beginner", Level ? gddMenuItemFlagChecked : 0, OnExpert );
}
function OnBeginer()
{
  options( "level" ) = false;
  RedrawAll();
}

//
// On24Hour
//
function OnExpert()
{
  options( "level" ) = true;
  RedrawAll();
}

function RedrawAll(){
	if(options("level")==true){
		mnBackground.src = "images/main_small.png";
		ColorButton.x = 103;
		gridx =9;
		gridy =9;	
		maxmines=10;
		view.resizeTo(200,250);
		divContentBeginner.visible = true;
		divContentExpert.visible = false;
		if(firstrun_beg==false){
			firstrun_beg = true;
			newgame();
			DrawBoard();
		}else{
			RestartGame();
		}
	}else{
		mnBackground.src = "images/main_big.png";
		ColorButton.x = 203;
		gridx =16;
		gridy =16;
		maxmines=40;
		view.resizeTo(300,370);
		divContentExpert.visible = true;
		divContentBeginner.visible = false;
		if(firstrun==false){
	firstrun = true;
	newgame();
	DrawBoard();
}else{
	RestartGame();
}
	}



}
function DrawBoard() {
  for (var i = 0; i < gridy; ++i) {
    for (var j = 0; j < gridx; ++j) {
	if(options("level")==true){
		divContentBeginner.appendElement('<button name="bgnr'+i+'_'+j+'" onclick="gridclick('+i+','+j+');" image="images/sqt0.png" overImage="images/sq_over.png" downImage="images/sq_down.png" x="'+j*blocksize+'" y="'+i*blocksize+'" />')
	}else{
		divContentExpert.appendElement('<button name="xprt'+i+'_'+j+'" onclick="gridclick('+i+','+j+');" image="images/sqt0.png" overImage="images/sq_over.png" downImage="images/sq_down.png" x="'+j*blocksize+'" y="'+i*blocksize+'" />')
	}
    }
  }
  ResizeBoard();
}
function ResizeBoard() {
if(options("level")==true){
	divContentBeginner.width = gridx * blocksize;
	divContentBeginner.height = gridy * blocksize;
}else{
	divContentExpert.width = gridx * blocksize;
	divContentExpert.height = gridy * blocksize;
}
}

function newgame() {
	var y;
		for(y = 0; y < gridy; ++y)
		{
			mines[y] = [false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false];
			shown[y] = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
		}

	var m;
	for(m = 0; m < maxmines; ++m) {
		var x,y;
			do {
				x = Math.floor(Math.random() * gridx);
				y = Math.floor(Math.random() * gridy);
			} while(mines[y][x]);
				mines[y][x] = true;
			}

		squaresleft = gridy * gridx;
		flagsleft = maxmines;
		elapsedtime = 0;
		playing = true;
		clicked = false;
		placeflag = false;

}

function RestartGame(){
newgame() 
	for(y = 0; y < gridy; ++y) {
		for(x = 0; x < gridx; ++x) {
		if(options("level")==true){
			eval("bgnr"+y+"_"+x).enabled = true;
			eval("bgnr"+y+"_"+x).image = "images/sqt0.png";
		}else{
			eval("xprt"+y+"_"+x).enabled = true;
			eval("xprt"+y+"_"+x).image = "images/sqt0.png";
		}
			
			//view.removeElement(eval("grd"+y+"_"+x));
			
			//eval("grd"+y+"_"+x).image = dir + "sqt0.png";
			//eval("grd"+y+"_"+x).enabled = true;
			//divContent.appendElement('<button name="grd'+y+'_'+x+'" onclick="gridclick('+y+','+x+');" image="images/sqt0.png" overImage="images/sq_over.png" downImage="images/sq_down.png" x="'+x*blocksize+'" y="'+y*blocksize+'" />')
		}
	}
	ResizeBoard();
	setStatus();
}

// clock tick handler
function ticker() {
	if (playing) {
		if (clicked) {
			elapsedtime++;
			setStatus();
			//view.setTimeout("ticker()", 1000);
		}
	}
}
function setStatus() {
	elapse3.src="images/"+(elapsedtime-(Math.floor(elapsedtime/10))*10)+".png";
	elapse2.src="images/"+(Math.floor((elapsedtime-(Math.floor(elapsedtime/100))*100)/10))+".png";
	elapse1.src="images/"+(Math.floor(elapsedtime/100))+".png";
	flag3.src="images/"+(flagsleft-(Math.floor(flagsleft/10))*10)+".png";
	flag2.src="images/"+(Math.floor((flagsleft-(Math.floor(flagsleft/100))*100)/10))+".png";
	flag1.src="images/"+(Math.floor(flagsleft/100))+".png";

}


// handler called whenever the grid is clicked
function gridclick(y,x) {
	x = event.srcElement.x;
	y = event.srcElement.y;
	if(x!=0) x = x / blocksize;
	if(y!=0) y = y / blocksize;

	if (playing) {
	
		clicked = true;
		if (placeflag) {
			if (shown[y][x] < 3) {
				var s = shown[y][x];
				var change = true;
					if (s == 1) {
						flagsleft++;
						squaresleft++;
					}
					if (flagsleft == 0 && s == 0) {
						change = false;
					}else {
						if (s == 2) s = 0;
						else s++;
						if (s == 1) {
							flagsleft--;
							squaresleft--;
						}
					}
					if (change) {
						shown[y][x] = s;
					//divContent.children("grd"+y+"_"+x).image = dir + "sqt"+s+".png";
					//divContent.children("grd"+y+"_"+x).enabled = false;
					event.srcElement.image = dir + "sqt"+s+".png";
					event.srcElement.enabled = false;
						setStatus();
					}
					if (squaresleft == 0) {
						playing = false;
					}
			}
		}else if (shown[y][x] != 1) {
			if (mines[y][x]) {
				//divContent.children("grd"+y+"_"+x).image = dir + "minered.png";
				event.srcElement.image = dir + "minered.png";
				event.srcElement.enabled = false;
				//divContent.children("grd"+y+"_"+x).enabled = false;
				dead();
			} else  {
				rollback(y,x);
			}	
	}
   }
}




function surrounding(y,x) {
	var count = 0;
	if (y > 0 && x > 0 && mines[y-1][x-1]) count++;
	if (y > 0 && mines[y-1][x]) count++;
	if (y > 0 && x < gridx-1 && mines[y-1][x+1]) count++;
	if (x > 0 && mines[y][x-1]) count++;
	if (x < gridx-1 && mines[y][x+1]) count++;
	if (y < gridy-1 && x > 0 && mines[y+1][x-1]) count++;
	if (y < gridy-1 && mines[y+1][x]) count++;
	if (y < gridy-1 && x < gridx-1 && mines[y+1][x+1]) count++;
	return count;
}


function rollback(y,x) {
if(options("level")==true){
			var _fix = "bgnr";
		}else{
			var _fix = "xprt";
		}
	if (y >= 0 && y < gridy && x >=0 && x < gridx) {
		if (shown[y][x] != 3) {
			var c = surrounding(y,x);
			shown[y][x] = 3;
			squaresleft--;
			eval(_fix+y+"_"+x).image = dir + "sq"+c+".png";
			eval(_fix+y+"_"+x).enabled = false;
			//divContent.children("grd"+y+"_"+x).image = dir + "sq"+c+".png";
			//divContent.children("grd"+y+"_"+x).enabled = false; 

			if (c == 0) {
				rollback(y-1,x-1);
				rollback(y-1,x);
				rollback(y-1,x+1);
				rollback(y,x-1);
				rollback(y,x+1);
				rollback(y+1,x-1);
				rollback(y+1,x);
				rollback(y+1,x+1);
			}
		}
	}
}

function dead() {
	var y, x;
	if(options("level")==true){
			var _fix = "bgnr";
		}else{
			var _fix = "xprt";
		}
	for(y = 0; y < gridy; ++y) {
		for(x = 0; x < gridx; ++x) {
			if (mines[y][x]) {
				if (shown[y][x] != 1) {
					eval(_fix+y+"_"+x).image = dir + "mine.png";
					//divContent.children("grd"+y+"_"+x).image = dir + "mine.png";
					//divContent.children("grd"+y+"_"+x).enabled = false; 
					eval(_fix+y+"_"+x).enabled = false;
				}
			}else if (shown[y][x] == 1) {
				//divContent.children("grd"+y+"_"+x).image = dir + "nomine.png";
				eval(_fix+y+"_"+x).image = dir + "nomine.png";
				//divContent.children("grd"+y+"_"+x).enabled = false; 
				eval(_fix+y+"_"+x).enabled = false;
			}else{
				eval(_fix+y+"_"+x).enabled = false;
				//divContent.children("grd"+y+"_"+x).enabled = false; 
			}
		}
	}
	playing = false;
	clicked = false;
}
